\ 80C196 single chip target control file

pto

Released for use with the MPE Forth Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

May 1991	Original release of v2

October 1991	80C196 version

\ 80C196 ROM Umbilical Forth target

only forth definitions decimal

  all from-file macros.fth		\ Load the macro file

\ Using Umbilical Forth with an EPROM emulator is a good way to work,
\ but finally an EPROM image file must be generated.

  $320 emu-base				\ output to emulator
  e27256 16bit output-emulator

\ The cross compiler can now be switched on

CROSS-COMPILE

  prefix				\ assembler opcodes first
  align-odd				\ headers word aligned
  no-log				\ no log
  no-heads				\ no dictionary

only forth definitions			\ initial target search order

\ define memory map

$2000 Equ Rom-start			\ start of usable ROM
$FFFF Equ Rom-end			\ end of usable ROM

$002C Equ Ram-start			\ start of usable RAM
$00FF Equ Ram-end			\ end of usable RAM
$0001 Equ #tasks			\ number of tasks
$0008 Equ User-size			\ size of each task's user area
$0020 Equ SP-size			\ size of each task's data stack
$0028 Equ RP-size			\ size of each task's return stack

$A000 Equ Appl-rom			\ Define application area
$C000 Equ Appl-rom-end			\ both start and finish


\ calculate memory map

ram-start equ init-u0			\

user-size sp-size + equ task-s0		\ initial offset of data stack
task-s0 rp-size + equ task-r0		\ initial offset of return stack

user-size sp-size + rp-size +		\
   equ per-task				\ memory used by each task

#tasks per-task * equ taskram		\ total memory needed for tasks

per-task ram-start + equ appl-ram	\

RP-size SP-size - equ max-depth		\ max no. of items on data stack

Ram-start task-r0 + equ init-r0		\ top of return stack
Ram-start task-s0 + equ init-s0		\ top of data stack

\ memory definitions                               sfp 10/05/91

     Rom-start Rom-end   KERNEL ROM196		\ Kernel ROM
     Appl-ram  Ram-end 0 KERNEL-RAM ROM196-DATA	\ Kernel RAM
               Ram-end   MEM-END		\ end of RAM

     Rom-start IN-EMULATOR ROM196		\ Output to emulator

use-code ROM196					\ Select code page
use-data ROM196-DATA				\ Select data page

\ System baud rate calculation

\
\ Calculate baud rate using system clock rate.
\ Check that the required baud rate matches the baud rate demanded
\ for BAUD at the end of this file.
\
\ Baudreg = xtal/(16*baud) - 1
\
decimal
10,000000				\ clock speed as double number in Hz
  16 mu/mod rot drop			\ divide by 16
9600					\ baud rate required
  um/mod nip				\ divide by baud rate
  1-					\ subtract one
  $8000 or				\ XTAL1 clock
  equ sysbaud				\ set baud rate

\ System equates

\
\ release numbers
\
$31 EQU MPE-REL
$31 EQU MPE-VER
$30 EQU USRVER

\
\ character equates
\
$20 EQU ABL
$0D EQU ACR
$2E EQU ADOT
$07 EQU ABELL
$08 EQU BSIN
$08 EQU BSOUT
$0A EQU ALF
$0C EQU FFEED

$00 EQU FALSE
 -1 EQU TRUE

\
\ RAM allocation
\ If Umbilical Forth is being used on a true single chip system
\ RAM allocation must be very tightly controlled.
\ The SFRs occupy 00..019h. The Forth virtual machine and scratch
\ space uses from 01Bh to 02Bh, so that additional registers are
\ available from 02Ch onwards.
\
there equ spshadow   1 allot-ram	\ character available
there equ rxchar   1 allot-ram		\ character read

\ pull in the files

  decimal all from-file sfr196			\ SFR equates for 80C196
  decimal all from-file messages		\ message equates for Umbilical Forth

  $2000 org					\ clear the vector area
  $2000 $80 $FF fill				\
  $2080 org					\ skip the vector area

  decimal all from-file startup			\ assembler startup code
  decimal all from-file min196			\ code words
  decimal all from-file drivers\sci196iu	\ interrupt driven SCI code
  decimal all from-file kernel			\ High level words
  decimal all from-file targend			\ message driver
  decimal

\ set up the CCB

     $EB  $2018 !       \ chip configuration byte
                        \ max 3 wait states
                        \ ALE, WRH- & WRL-, 16 bit, powerdown enabled
     $27  $201A c!      \ JMP SELF opcode
     $FE  $201B c!

  UMBILICAL-FORTH
