\ Definitions of DEFER for Umbilical Forth

: crash  ;	\ -- ; needed by cross compiler 

: (to-do)	\ cfa -- ; sets CFA into RAM of target word whose CFA follows
  r> dup 2+ >r				\ step return address over target
  @ 3 +					\ form PFA of target
  @					\ fetch RAM address from PFA
  !  ;					\ store CFA in target RAM

((
\ High level version
: defer		\ --
  create  there ,  ['] crash ,(r)  does> @ @ execute  ; 
))
((
\ low level version, but DEFER already exists in the host
: defer		\ -- ; ??? -- ??? [child]
  create  there ,  ['] crash ,(r)  ;code
  pop ax   ld bx ax []                  \ address of data in RAM
  ld ax bx []                           \ get CFA
  br ax []   end-code                   \ go do it
))

assembler
here is-action-of defer
  pop ax   ld bx ax []                  \ address of data in RAM
  ld ax bx []                           \ get CFA
  br ax []				\ go do it
forth
