((

	XDTC50-5

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1990

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))



2 Constant Single-size			\ size of variable in bytes
4 Constant Double-size			\ size of Double variable in bytes
6 Constant Float-size			\ size of Fvariable in bytes


\ Close-Image Free-Comp-Mem Error-Exit Abort-Exit XC-Error .. sfp 21/02/90
\

Only Forth Also C-C Definitions

: .Text-file		\ -- ;
  $15 op-handle @ ioctl drop		\
;

: $Fnumber?		\ a -- 0 | n1 1 | n1 n2 2 | n1 n2 n3 3
  dup count upper			\ convert to upper case
  cs> swap				\ make into long address
  base @ ($Fnumber?)			\ call public word
;

: floats                                \ -- ; allow f.p. input
  assign $fnumber? to-do number?  ;     \ switch in fnumber?
  public
  
: Close-Image	( -- ; close image, whether emulator or file )
  0 in-emulator?
  If
    close-emulator
  Else
    close-disk
  Endif  ;


: Free-Compiler-Mem  ( -- ; free all external compiler memory )
	release-files			\ release text source files
        free-init-ram                   \ release initialised RAM table
        free-symbol-space  ;            \ release symbol table


: Error-Exit	( -- )
        free-compiler-mem               \ release compiler memory
	bye  ;				\ leave


\ action of ABORT
: Abort-Exit  ( -- )
        assign bye to-do abort          \ avoid recursive errors
        close-log
	emulator?
        If  close-emulator  Endif	\ shut down emulator if needed
        curr-code-page @(g) in-emulator? 0=     \ writing a file?
        If  close-image  Endif
        error-exit  ;


: XC-Error	( error# -- )
	set-error
	disp-error	\ show error
	.where		\ show error position
	close-log		\ close log & >screen
	emulator?
        If  close-emulator  Endif	\ shut down emulator if needed
        curr-code-page @(g) in-emulator? 0=     \ writing a file?
        If  close-image  Endif
	Error-Exit  ;



\ Abort-Compilation .. sfp 21/02/90
\


: Abort-Compilation	( -- )
	close-log
	emulator?
        If  close-emulator  Endif	\ shut down emulator if needed
        curr-code-page @(g) in-emulator? 0=     \ writing a file?
        If  close-image  Endif
	cr cr
	cr ." *****************************"
	cr ."       USER INTERVENTION      "
	cr ."   CROSS COMPILING ABANDONED  "
	cr ." *****************************"
	only Forth definitions
	Error-Exit  ;




\ Abandon .. sfp 21/02/90
\


decimal

: Abandon	( -- )
  key?					\ user pressed a key ?
  If					\ yes,
    key 3 =				\  was it a control-C ?
    If					\  yes,
        abort-compilation	\    give up the ghost ...
    Else					\  no,
        key drop			\    wait for user
    Endif
  Endif  ;




\ Forward references .. Jon 09/08/88
\


	cr cr	.( Loading forward referencing ... )
	cr




\ Forward references .. sfp 24/03/87
\



: ?B-D	( -- t/f ; if CC is compiling and we are between <BUILDS and DOES> )
	compil?  State @  0<>  and  ;



: ?BD-Literal	( n -- ; compile into C-C if in <builds ... does> )
	?b-d
	If
		compile LIT  ,
	Else
		drop
	Endif  ;



: Value,	( val -- ; allow for <builds ... does> )
	dup ,(t)  ?bd-literal  ;



: Literal	( val -- )
	target LIT compile-ref value,  ;



: Compile-Num	( d | n -- )
	Dpl @ 1+
	If
		swap literal
	Endif
	literal  ;




\ cur-voc-nfas thread, .. sfp 15/08/88
\


: Cur-Voc(s)	(( -- addr(s) ))
	current(s) 2@(p)  ; 	\ current target voc


: Cur-#Threads(t)	( -- n )
	#threads(t)  ;		\ number of threads in it


: Thread,	( -- )
  here c@  here 1+ c@ +			\ count + first letter
  cur-#threads(t) 1- and cell*		\ mask to get hash code
  cur-voc(s) t-nfa+ rot +		\ index into nfas
  2dup @(s)l ,(t)			\ lay down old value
  here(t) -rot !(s)l  ;			\ and update nfas table




\ Forward references .. sfp 15/08/88
\


: (Host-Create)	( -- ; make symbol head )
  cs> here $create(s)  ;


: (Head-Create)	( -- ; INTERPRETER head )
\ here dup 2 cells+ here c@ 1+ cmove>	\ copy string up for ModForth2
  here dup  cell+ here c@ 1+ cmove>	\ copy string up for ModForth3
  header  lay:				\ header and do-colon
  state on  ;				\ host's compiler on




\ Resolved-Symbol .. Jon 10/08/88
\


: Resolved-Symbol	(( n -- sym-val-fld(d) ))
  (host-create) ,(s) 2 zeros,(s)
  is-resolved latest-chunk @(v) last'(s)@ ;




\ Host-Create .. Jon 11/08/88
\


: Host-Create	( n -- )
  cs> 'word Current(s) 2@(p)		\
  voc-chunk+ @(s)l latest-chunk @(p)l	\
  v-find(s)				\ Symbol exists ?
  If					\  Yes,
    2dup resolved?			\   Symbol resolved ?
    If					\    Yes,
      2drop cr here .name		\
      ."  is redefined" cr		\      Redefine it,
      resolved-symbol			\
    Else				\ Otherwise,
      2dup >r >r resolve r> r>		\   resolve it,
    Endif				\   mark as target
  Else					\   symbol.
    drop resolved-symbol		\
  Endif					\
  'latest(s) 2!(v)  ;			\ addr of last host




\ Forward references .. sfp 21/02/90
\


hex

: Target-Create	( -- addr ; modified for leading link field )
  here dup c@ width(t) @(g) min ?dup
  If
    ?0-even					\ link on even boundary
    thread,					\ lay thread link
    here(t) last(t) !(g)		\ mark NFA
    over c@ 080 or c,(t)  0		\ lay count byte
    Do
      1+ dup c@ c,(t)
    Loop						\ and text
    drop
  Else
    drop
  Endif
  ?force-align
  here(t)						\ CFA is aligned too
;



\ Forward references .. Jon 10/08/88
\


: Create	( -- )
  target-create host-create  ;

: Forward-Error	( -- )
  ?b-d 01B ?error  ;

: Forward-Create	( -- )
  forward-error
  (host-create) 3 zeros,(s)		\ Forward ref. symbol
  latest-chunk @(v) last'(s)@ cell(s)+ ref!  ;		\ forward ref. packet





\ compile-number interp-number assemble-number .. sfp 21/09/89
\


: Compile-Number  ( -- )
  'word number? ?dup
  If
    Case
      1  Of  literal  Endof
      2  Of  swap literal literal  Endof
      3  Of  rot literal  swap literal  literal  Endof
    EndCase
  Else
    sc/c(s)-page sc/c(s) forward-create ,(t) rc/c(s)
  Endif  ;


: Interp-Number  ( -- n | d )
  'word number? ?undef  ;


: Assemble-Number  ( -- n | d )
  'word number? 0=
  If
    sc/c(s)-page  0 curr-page!  sc/c(s)
    'labels(s) 2@(g) set-definitions(s)
    forward-create
    rc/c(s)
  Endif  ;




\ find(p) ('word(p)) .. J Lee -- 16/08/90
\


global-var found-sym-page	\ symbol page where symbol found


: Find(p)	( -- seg off TRUE | FALSE ; search in all pages )
  curr-page@ >r		\ preserve curr-page
  FALSE			\ false flag
  #Pages 0			\ for all pages
  ?Do
    drop
    i dup page-chunk@ swap data-page? not  and  \ only search pages that exist
    If
      i curr-page!			\ set as page
      cs> 'word find(t)			\ found?
      ?dup ?LEAVE
    Endif
    FALSE					\ leave false flag
  Loop
  r> curr-page!  ;		\ restore curr-page


: ('word(P))	( -- addr page TRUE | FALSE ; search all pages )
	curr-page@ >r		\ preserve curr-page
	FALSE			\ false flag
	#Pages 0			\ for all pages
	?Do
		drop
		i dup page-chunk@		\ only search pages that exist
                swap data-page?
                If
                        data-search @(g)
                Else
                        TRUE
                Endif
                AND
		If
			i curr-page!			\ set as page
			cs> 'word find(t)		\ found?
			If
 				2dup resolved?
				If
                                        2dup c/v?
                                        If  cell(s)+ 2@(s)l cell(s)+ @(s)l
					Else  @(s)l	\ get target addr
                                        Endif
					i dup found-sym-page !(g)
					>page-table page.id @(g)	\ get target page id
					TRUE			\ leave true flag
					LEAVE		\ and exit loop
				Else
					2drop		\ drop symbol (check other pages)
				Endif
			Endif
		Endif
		FALSE					\ leave false flag
	Loop
	r> curr-page!  ;		\ restore curr-page




\ Primitives .. Jon 10/08/88
\

	cr cr	.( Loading primitives .......... )
	cr


hex

: ?Interpreter	( -- )
  Interpreter context-find
  If
    execute r> drop
  Endif  ;


: ?Compiler	( -- )
  Compiler context-find
  If
    execute r> drop
  Endif  ;


: ?Assembler	( -- )                                       
  Asm-Access context-find
  If
    execute r> drop
  Endif  ;

: ?Equates	( -- )
  cs> 'word 'Equates(s) 2@(g) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
  If
  	@(s)l compil?
  	If
  		literal
  	Endif
  	r> drop
  Else
  	drop
  Endif  ;




\ Primitives .. Jon 04/01/89
\


: ?Labels	( -- )
  cs> 'word 'Labels(s) 2@(g) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
  If
  	compil?
  	If
  		target LIT compile-ref ref value,
  	Else
  		sc/c(s)-page  0 curr-page!  sc/c(s)
  		'labels(s) 2@(g) set-definitions(s)
  		ref
  		rc/c(s)
  	Endif
  	r> drop
  Else
  	drop
  Endif  ;


: ?C-C	( -- )
	c-c context-find
	If
		execute  r> drop
	Else
		forth context-find
		If
			execute r> drop
		Endif
	Endif  ;




\ ?c/v .. Jon 06/01/89
\

: Get-single	( 'packet -- n1 )
  Cell(s)+ @(s)l			\
;

: Get-double	( 'packet -- n1 n2 )
  cell(s)+ 2dup @(s)l >r		\ Get next two words
  cell(s)+      @(s)l >r		\
  r> r>					\
;

: Get-float	( 'packet -- n1 n2 n3 )
  cell(s)+ 2dup @(s)l >r		\ Get next three words
  cell(s)+ 2dup @(s)l >r		\
  cell(s)+      @(s)l >r		\
  r> r> r>				\
;

: Get-number	( d-addr -- n1 )
  cell(s)+ 2@(s)l			\ packet addr
  Case 2dup @(s)l			\ type of packet
    Single-size of Get-Single Endof	\ Get 16-bit value
    Double-size of Get-Double Endof	\ Get double number
    Float-size  of Get-Float  Endof	\ Get Floating point number
    2Drop				\ Discard d-addr
  End-case				\
  r> r> 2drop 				\ Go back 2 levels
;

: ?c/v	( -- addr t | f )
  cs> here find(t) dup				\ Look for symbol
  If		    				\ Found it ?
    drop 2dup c/v? 				\  is it a c/v ?
    If
      cell+ 2@(s)l cell+ TRUE		\   yes, leave addr, flag
    Else
      2drop FALSE 			\   no, just leave flag
    Endif
  Endif  ;




\ Primitives .. Jon 10/08/88
\


hex



: Compile-cc	( if in <builds .. does> compile name at HERE into x-compiler )
  ?b-d					\ <builds ... does> ?
  If					\
    ?c/v				\ target constant or variable 
    If					\
      @(s)l compile lit ,		\
    Else				\
      ?in-root				\ in FORTH vocab. ? 
      0>				\ immediate word ?
      If   execute			\ do it
      Else ,				\ compile it
      Endif				\
    Endif				\
  Endif  ;				\




\ ?Target .. sfp 14/04/89
\

: Set-voc	( d-addr -- )
  is-voc(s)				\ Set vocabulary
  r> r>	2drop				\ Go back 2 levels
;

: ?Target	( -- c/v | nil ; local to a page )
  cs> here find(t)			\ Search for symbol. Found it?
  If	 				\ Yes,
    compil?				\   Compiling?
    If					\   Yes,
      compile-ref compile-cc		\     Compile references
      r> drop				\     exit
    Else				\ No,
      Case 		      		\   Constant, Variable or Vocabulary?
        2dup voc? ?of Set-voc    Endof	\    A Vocabulary
        2dup c/v? ?of Get-number Endof	\    A Constant or Variable
        2drop				\    Neither, discard address
      End-case				\
    Endif				\
  Endif					\
;


: ?Page-Target	( -- c/v | NIL ; inter page )
  find(p)				\
  If					\
    2dup c/v? 				\ is it a c/v?
    If					\
      cell(s)+ 2@(s)l cell(s)+ @(s)l	\ ? De-Ref. c/v
      r> drop exit			\ and leave
    Else				\
      2drop				\
    Endif				\
  Endif  ;
				



\ ?Inter-Page-Ref Pages .. J Lee -- 15/08/90
\


: Inter-Page-Ref	(( symbol-addr(d) page# -- ; compile inter page call ))
	-rot							\ hide page#
	@(s)l literal					\ compile addr as a literal
	>page-table page.id @(g)
	literal						\ lay target page id
	target PAGE-WORD compile-ref  ;	\ compile 'PAGE-WORD'


: ?unres-inter-page	(( sym-addr(d) -- ; check resolved inter page call ))
	resolved? 0=
	If
		cr 'word $. ."  is an unresolved inter page call " abort
	Endif  ;

global-var page-call  1 page-call !(g)
: ?Pages	( -- ; compile an inter page reference if found )
	curr-page@
	0				\ dummy flag to drop
	#Pages 0
	?Do
		drop
		dup i <>
		If				\ check only if not curr-page
			i page-chunk@				\ get base chunk
			If
				i curr-page!			\ set as page
				cs> 'word find(t)		\ found?
				If
					2dup ?unres-inter-page
					rot dup curr-page! -rot	\ reset curr-page
					i 0<>			\ not in page 0 (SPLIT model)
					If
						i inter-page-ref
					Else
						compile-ref		\ compile as a ref
					Endif
					-1 LEAVE		\ leave loop with true flag
				Endif
			Endif
		Endif
		0 					\ on last iteration leave false flag
	Loop
	swap curr-page!
	If
		r> drop  EXIT		    \ jump back into interpreter/compiler	
	Endif  ;





\ Outer Interpreter .. Jon 04/01/89
\


	cr cr	.( Loading Outer Interpreter ... )
	cr


: Interpreting	( -- )
  ?interpreter ?equates ?labels
  ?target ?page-target ?c-c interp-number  ;


: Compiling	( -- )
  ?compiler ?target ?equates
  ?labels ?pages compile-number  ;


: Assembling	( -- )
  ?assembler ?interpreter ?equates ?labels
  ?target ?page-target ?c-c assemble-number  ;

\ Outer Interpreter .. sfp 19/09/89
\


: Interpret(cc)	( -- )
  Begin
    abandon
    Host-Mode @(g)
    If
      bl word c@ 0=
      If  exit  Endif
      'word find ?dup
      If
	0<  state @  and
	If   ,
	Else execute
	Endif
      Else
	number? dup ?undef
	State @
	If   #literal
        Else drop
        Endif
      Endif
    Else
      get-token c@ 0=  If  exit  Endif
\  ."  | " here count type  space
      compil?
      If   
        compiling
      Else
        interp?
	If   interpreting
	Else assembling
	Endif
      Endif
    Endif
\ $525d $78c @(s)l $5b74 = If ." hello" quit endif
    ?stack
  Again  ;


defer INTERPRET(T)		assign INTERPRET(CC) to-do INTERPRET(T)




\ $from .. sfp 12/01/90
\


: $From	( first last $addr-l -- )
	Blk @ >r  >in @ >r  blk off
	get-stream next-file		\ open next file
	dup ?error
	pcr 						\ go to starting page
        redraw-bottom-bar
        ." Source text file: " .Text-file cr		\
	Begin
		next-line
	While
		interpret(t)
	Repeat
	op-handle @ set-op-handle prev-file dup ?error
	pcr ." Finished." pcr
        redraw-bottom-bar
	r> >in !  r> blk !
	Blk @ 0=						\ if keyboard, null line
	If
		#tib off  >in off
	Endif  ;






: 0,(r)'s	( size -- )
  0 ?Do 0 ,(r) Loop ;

: 0,(t)'s	( size -- )
  0 ?Do 0 ,(t) Loop ;

: Rom-set(t)  ( size -- addr )
  there(t) tuck ,(t)			\ Place initialised ram addr
  kernel-ram-page @(g)			\ same page?
  curr-data-page @(g)  =		\
  If   0,(r)'s				\ Yes,
  Else cell(t) * allot-ram		\ No,
  Endif  ;

: Rom-Var(t)  ( -- addr )
  Target VARIABLE compile-run		\ Get run-time reference
  1 Rom-set(t)				\
;

: Ram-Var(t)  ( -- addr )
  docreate,
  here(t) 1 0,(t)'s ;

: Rom-Double(t)  ( -- addr )
  Target 2VARIABLE compile-run		\ Get run-time reference
  2 Rom-set(t)				\
;

: Ram-Double(t)  ( -- addr )
  docreate,
  here(t) 2 0,(t)'s ;

: Rom-Float(t)  ( -- addr )
  target FVARIABLE compile-run		\
  3 Rom-set(t)				\
;

: Ram-Float(t)  ( -- addr )
  docreate,
  here(t)  3 0,(t)'s ;

\ Rom-Voc(t) Ram-Voc(t) .. sfp 14/04/89
\


: Rom-Voc(t)	(( #threads t-cfa -- ^threads(r) ))
	there(t) dup >r ,(t)		\ lay ^#threads & save copy
	Voc-Link(t) @(g) ,(t)		\ update voc-link(t) with t-cfa
	Voc-Link(t) !(g)
	dup ,(r)  0
	?Do
		0 ,(r)
	Loop						\ zero allotted threads
	r> cell+  ;				\ retrieve ^threads


: Ram-Voc(t)	( #threads t-cfa -- ^threads )
	Voc-Link(t) @(g) ,(t)		\ update voc-link(t) with t-cfa
	Voc-Link(t) !(g)
	here(t) >r				\ save ^threads
	dup ,(t) 0
	?Do
		0 ,(t)
	Loop						\ zero alloted threads
	r> cell+  ;




\ Primitives .. Jon 19/08/88
\


hex

	cr cr	.( Loading Primitives .......... )
	cr


: Voc(t)	( -- ^threads )
	"" VC" here(t) .log				\ log it to user
	here(t)
	target VOCABULARY Compile-run		\ vocabulary run-time-ref
	cur-#threads(t) swap ?ROM @(g)	\ #threads for this voc.
	If							\ ROM version
		Rom-voc(t)
	Else							\ RAM version
		Ram-voc(t)
	Endif  ;




\ Primitives .. sfp 16/08/88
\


hex

: Voc(h)	( -- ; build new vocab )
  create  (make-voc)			\ build new host vocab
  latest-chunk @(v) last'(s)@		\ return seg offset of symbol
  create-voc-chunk			\ create a new voc chunk
  -rot link-voc-chunk			\ set pointer in voc symbol
  voc(t)				\ build target vocab
  'latest(s) 2@(v) t-vp+ !(s)l		\ stash CONTEXT addr
  'latest(s) 2@(v)			\
  status+ mark-voc  ;			\ mark symbol as vocab


: Create(cc)	( address-of-does-section -- )
  get-token drop create			\ header
  "" CR" here(t) .log				\ log cfa to user
  compile-run  ;					\ lay cfa




\ Is-Action-Of .. sfp 14/04/89
\


: Is-Action-Of	( addr -- ; here is-action-of <name> )
	[compile] target  resolve-def-word  ;




\ Primitives .. Jon 09/08/88
\


: ([)	( -- ; turn cross-compiler's interpreter on )
	State(t) off(g)  ;


: (])	( -- ; turn cross-compiler's compiler on )
	1 State(t) !(g)  ;


: ([Compile])	( -- <word> ; compile word )
	cs> get-token find(t)
	If
		compile-ref ?b-d
		If
			?in-root ,
		Endif
	Else
		forward-create ,(T)
	Endif  ;




\ ",[T] .. sfp 21/02/90
\


hex


: ",(T)	( -- <string> ; compile string )
	022 word
	dup c@ 1+ cmove,(t)
	?bl-even
	?b-d
	If
		here c@ 1+ allot  even(h)
	Endif  ;




\ Primitives - File handling for USING definitions .. sfp 27/03/87
\


: Restore-Prev	( -- ; restore file saved in PREV-PCB )
	pcr ." Finished with " .scr		\ say so
	re-using						\ re-open file
	pcr pcr  ;




\ Primitives - Conditional compilation .. sfp 26/03/87
\

: C-Endif	( -- ; doesn't do anything )
;

: C-Else	( -- ; scan text until ENDIF )
  Begin
    Begin
      get-token c@ 0=
      While
        Obtain-line 0= If exit Endif
    Repeat
    "" )ENDIF" $here=
  Until
;

: C-If	( -- ; scan text until ELSE or ENDIF if top-of-stack is false )
  0=
  If
    Begin
      Begin
          get-token c@ 0=
        While
          Obtain-line 0= If exit Endif
      Repeat
      "" )ELSE(" $here=
      "" )ENDIF" $here=  or
    Until
  Endif
;




\ Primitives .. J Lee 1/8/90
\


\ : (-Text	( -- )
\	[ also from-voc ]
\	blk @				\ loading from blocks ?
\	If
\		[compile] (		\ yes, do old version
\	Else
\		[compile] (		\ no, text file version :- same word!!!
\	Endif
\	[previous]  ;




\ Primitives **************************** .. sfp 21/09/89
\


: '(T)	( -- cfa ; in Forth-83 ' is not immediate )
	cs> get-token find(t) ?undef	\ must be defined
	2dup resolved? ?undef		\ error if forward ref
	@(s)l >ca(t)  ;


: ['(T)]	( -- ; compile CFA as a literal )
	target LIT compile-ref
	cs> get-token find(t)
	If
		ref >ca(t)
	Else
		compil? ?undef
		forward-create
	Endif
	value,  ;


: ('(p))	( -- addr page TRUE | FALSE <name> ; collect string from input )
	get-token drop	\ get string to search for
	('word(p))  ;


: '(P)	( -- addr page ; search all pages )
	('(p))
	0=  If  cr ." Can't find " 'word $. ."  in any page"  abort  Endif  ;


: ['(P)]	( -- ; compile CFA as a literal )
	('(p))				\ search for string
	If
		swap
		target LIT compile-ref
		,(t)					\ lay addr
		target LIT compile-ref
		,(t)					\ lay page
	Else
		cr ." Can't forward reference " 'word $. ." across pages"
		abort
	Endif  ;




\ Compiler .. sfp 19/09/89
\


hex

	cr cr	.( Loading Compiler ........... )
	cr


only forth  also c-c  also compiler definitions  c-c

: :	CC/C
	?exec  ;

: ;	CC/C
	?csp target EXIT compile-ref
	?b-d
	If
		compile EXIT
	Endif
\	'latest: 2@(v) smudge(s)
	([)  state off  ;


: [']	CC/C
	['(t)]  ;


: ['P]	cc/c
	['(p)]  ;


: Begin	CC/C
	?comp  mrk<  ?b-d
	If
		[compile] BEGIN                               
		drop
	Endif
	1  ;


: Endif	CC/C
	?comp 2 ?pairs ?b-d
	If
		2 [compile] ENDIF
	Endif
	>res  ;


: Then	CC/C
	[+compiler] ENDIF [previous]  ;




\ Compiler .. J Lee -- 10/07/90
\


: Do	CC/C
	target (DO) compile-ref mrk> mrk<  ?b-d 
	If
		[compile] DO
		drop
	Endif
	3  ;


: ?Do	CC/C
	target (?DO) compile-ref mrk> mrk<
	?b-d 01c ?error  3  ;


: Loop	CC/C
	3 ?pairs  ?b-d
	If
		3 [compile] LOOP
	Endif
	target (LOOP) compile-ref <res >res  ;


: -->	CC/C
	[compile] -->  ;


: [Compile]	CC/C
	([compile])  ;


: Smudge	CC/C
	target SMUDGE compile-ref  ;


: [	CC/C
	([)  ;


: ]	CC/C
	target ] compile-ref  ?b-d
	If
		compile (])
	Endif  ;




\ Compiler .. sfp 26/03/87
\


: +Loop	CC/C
	3 ?pairs  ?b-d
	If
		3 [compile] +LOOP
	Endif
	target (+LOOP) compile-ref  <res >res  ;


: Leave	CC/C
	target (LEAVE) compile-ref  ?b-d
	If
		compile LEAVE
	Endif  ;


: ?Leave	CC/C
	target (?LEAVE) compile-ref  ?b-d
	If
		compile ?LEAVE
	Endif  ;


: Until	CC/C
	1  ?pairs  ?b-d
	If
		1 [compile] UNTIL
	Endif
	target ?BRANCH compile-ref <res  ;


: Again	CC/C
	1 ?pairs  ?b-d
	If
		1 [compile] AGAIN
	Endif
	target BRANCH compile-ref <res  ;




\ Compiler .. sfp 26/03/87
\


: Repeat	CC/C
	?b-d
	If
		>R
	Endif
	>r >r
	[+compiler] AGAIN [previous]
	r> r>  ?b-d
	If
		r>
	Endif
	2-
	[+compiler] ENDIF [previous]  ;


: If	CC/C
	target ?BRANCH compile-ref  mrk>  ?b-d
	If
		[compile] IF
		drop
	Endif
	2  ;


: Else	CC/C
	2 ?pairs  ?b-d
	If
		2 [compile] ELSE
		drop >r
	Endif
	target BRANCH compile-ref mrk>  swap  >res  ?b-d
	If  r>  Endif
	2  ;


: While	CC/C
	[+compiler] IF [previous]  2+  ;




\ Compiler .. sfp 19/10/89
\


: ,	CC/C
  target , compile-ref ?b-d		\
  If					\
    compile ,(t)			\   compile to ram
  Endif					\
;


: c,	CC/C
  target C, compile-ref  ?b-d		\
  If					\
    compile c,(t)			\   compile to ram
  Endif					\
;

: c,(r)	cc/c
  target C, compile-ref  ?b-d		\
  If compile c,(r) Endif		\
;

: ,(r)	cc/c
  target , compile-ref  ?b-d
  If  compile ,(r)  Endif  ;


: @	CC/C
  target @ compile-ref			\
  ?b-d					\
  If					\
    compile @(x)			\   compile to ram
  Endif					\
;


: C@	CC/C
  target C@ compile-ref			\
  ?b-d					\
  If					\
    compile c@(x)			\
  Endif
;

: !	CC/C
  target ! compile-ref
  ?b-d
  If
    compile !(x)			\   compile to ram
  Endif
;


: C!	CC/C
  target C! compile-ref			\
  ?b-d					\
  If					\
    compile !(x)			\   compile to ram
  Endif					\
;


: +!	CC/C
  target +! compile-ref			\
  ?b-d					\
  If					\
    compile !(x)			\   compile to rom
  Endif					\
;




\ Compiler .. sfp 19/09/89
\


: Cmove	cc/c
  target CMOVE compile-ref		\
  ?b-d					\
  If					\
    compile CMOVE(t)			\
  Endif					\
;

: Erase	cc/c
  target ERASE compile-ref		\
  ?b-d					\
  If					\
    compile ERASE(t)			\
  Endif					\
;

: Fill	cc/c
  target FILL compile-ref  ?b-d
  If  compile FILL(t)  Endif  ;




\ Compiler .. Jon 17/11/88
\

: Does>	CC/C
  ?b-d
  If
    compile EXIT
    State off
  Endif
  target (;CODE) compile-ref
  here(t) 'Latest: 2@(v) resolve-def-word
  DODOES,  ;


: Literal	CC/C
	literal  ;


: DLiteral	CC/C
	swap literal literal  ;




\ Compiler .. sfp 19/03/90
\


hex

: .(	CC/C
	029 word count type  ;


: ."	CC/C
	target (.") compile-ref  ?b-d
	If
		compile (.")
	Endif
	",(t)  ;


: ""	CC/C
	target (") compile-ref  ?b-d
	If
		 compile (")
	Endif
	",(t)  ;


: Abort"	CC/C
	target (ABORT") compile-ref ?b-d
	If  compile (ABORT")  Endif
	",(t)  ;


: ",	cc/c
	target ", compile-ref  ?b-d
	If  compile ",(t)  Endif  ;


: )	CC/C
	9 error  ;


: )) CC/C
	9 error  ;


: "	CC/C
	9 error  ;




\ ( \ recurse .. sfp 13/03/90
\


: (	cc/c
	[compile] (  ;


: (( cc/c
	[compile] ((  ;


: \	cc/c
	[compile] \  ;


: Recurse	cc/c
	'Latest(s) 2@(v) compile-ref  ;




\ Compiler - Eaker's CASE statement .. sfp 19/09/89
\


	cr cr	.( Compiler CASE is HOST and TARGET dependent )
	cr


: Case	CC/C
	?comp  Csp @ !csp  4  ;


: Of	CC/C
	4 ?pairs
	target (OF) compile-ref mrk>  ?b-d
	If
		4 [compile] OF
		drop
	Endif
	5  ;


: ?Of	cc/c
	4 ?pairs
	target ?BRANCH compile-ref  mrk>  ?b-d
	If
		5 [compile] ?BRANCH
		here 0 ,
	Endif
	5  ;




\ Compiler - Eaker's CASE statement .. sfp 26/03/87
\


: Endof	CC/C
	5 ?pairs  ?b-d
	If
		5 [compile] ENDOF
		drop >r
	Endif
	target BRANCH compile-ref mrk>  swap  >res  ?b-d
	If  r>  Endif
	4  ;


: EndCase	CC/C
	4 ?pairs  ?b-d
	If  compile DROP  Endif
	target DROP compile-ref
	Begin
		sp@ Csp @ <>
	While
		2 [+compiler] ENDIF [previous]
	Repeat
	Csp !  ;




\ Compiler .. sfp 28/03/87
\


: Here	CC/C
  target HERE compile-ref  ?b-d
  If  compile HERE(T)  Endif  ;


: There	CC/C
  target THERE compile-ref  ?b-d
  If  compile THERE(T)  Endif  ;


: Allot	CC/C
  target ALLOT compile-ref  ?b-d
  If  compile ALLOT(T)  Endif  ;


: Allot-Ram	CC/C
  target ALLOT compile-ref  ?b-d
  If  compile ALLOT-RAM  Endif  ;


: Word	CC/C
  target WORD compile-ref  ?b-d
  If compile WORD(T)  Endif  ;


: Ascii	CC/C
  bl word 1+ c@  literal  ;




\ create -- with defining mode  create ... ;code .. Jon 10/08/88
\


: Create	CC/C
  3 zeros,(s)   				\ expand reference packet
  'Latest: 2@(v) status+ mark-def-word
  target CREATE compile-ref	\ create in target
  Do-Build @(g)				\ is image-in-host allowed ?
  If
    sc/c  Interpreter definitions
    word-down context-find 0=
    If
      (head-create)
      compile LIT 'Latest: 2@(v) swap , 
      compile LIT ,
      compile CREATE(CC)
    Else
      drop
    Endif
    rc/c
  Endif  ;




\ ;code - with defining mode create ... ;code .. sfp 10/02/90
\


: ;Code	CC/C
	?csp  ?b-d
	If
		compile EXIT
	Endif
	State off
	target (;CODE) compile-ref
	here(t) 'Latest: 2@(v) resolve-def-word
	2 State(t) !(g)  sp@
	asm_start initfwd  ;




\ conditional compilation  assign to-do .. sfp 25/03/87
\


: If(	CC/C
	c-if  ;


: )Else(	CC/C
	c-else  ;


: )Endif	CC/C
	c-endif  ;


: Assign	CC/C	( -- ; compiles cfa )
	['(t)]  ;


: To-Do	CC/C
	target (TO-DO) compile-ref  ;		\ compile action




\ vocabulary switching .. sfp 25/03/87
\


\ allow vocabulary switches after HOST-COMPILATION
: CC/C	CC/C
	[compile] CC/C  ;	IMMEDIATE


: C-C	CC/C
	[compile] C-C  ;	IMMEDIATE




\ Interpreter .. sfp 14/04/89
\


hex

	cr cr	.( Loading Interpreter ........ )
	cr


only forth  also c-c  also interpreter definitions  c-c

: Make-turnkey cc/i
  the-label STRT 2dup resolved?		\ Cold start vector exists?
  If  					\ Yes,
    @(s)l				\
    bl-word-up				\ 
    cs> 'word Current(s) 2@(p)		\
    voc-chunk+ @(s)l latest-chunk @(p)l	\
    v-find(s)				\   Symbol exists ?
    If					\   Yes,
      2dup resolved?			\     Symbol resolved ?
      If				\     Yes,
        @(s)l Swap !(t)			\       save word addr at startup vector
      Else				\     No,
        2Drop Drop 0 error		\       cannot set if not defined
      Endif				\
    Else				\   No,
      2Drop 0 error			\     cannot set if not defined
    Endif				\
  Else					\ No,
    2Drop 0 error			\   cannot set if startup doesn't exist
  Endif					\
;

: Allot	CC/I
	allot(t)  ;


: ",	CC/I
	",(t)  ;


: .(	CC/I
	[compile] .(  ;


: ." CC/I
	[compile] ."  ;


: )	CC/I
	9 error  ;


: )) CC/I
	9 error  ;


: "	CC/I
	9 error  ;

: :	CC/I
	(])  !csp
	Current(s) 2@(p) Context(s) 2!(p)
	bl-word-up  create
	"" : " here(t) .log
	target : Compile-Run
	'Latest(s) 2@(v) 'Latest: 2!(v) ;


: D.	CC/I
  D. ;

\ Interpreter .. sfp 05/06/90
\


: [']	CC/I
	['(t)]  ;


: '	CC/I
	'(t)  ;


: 'P	cc/i
	'(p)  ;


: Assembler	CC/I
	2 State(t) !(g) sp@  asm_start initfwd  ;



: Code	CC/I
	?0-even  get-token drop  create
	"" CD" here(t) .log
	[+interpreter] ASSEMBLER [previous]  ;


: Here	CC/I
  here(t)  ;


: ;S	CC/I
	 r> r> r> 2drop drop  ;


: Latest	CC/I
	latest(t)  ;




\ Interpreter .. sfp 14/04/89
\


hex

: [compile]	CC/I
	([compile])  ;


: Toggle	CC/I
	toggle(t)  ;


: Immediate	CC/I
	040 'Latest(s) 2@(v) >name(s) set-bit(s)
	Width(t) @(g)
	If
		latest(t) 040 toggle(t)
	Endif  ;




\ Interpreter .. sfp 15/08/88
\


hex

: Vocabulary	CC/I
  ?0-even  cs> get-token find(t)
  If
    2dup voc?
    If
      create			\ resolve symbol
      voc(t)			\ make target
      -rot t-vp+ !(s)l	\ stash address
    Else
      drop voc(h)
    Endif
  Else
    voc(h)
  Endif  ;


: Ascii	CC/I
	bl word 1+ c@  ;




\ Interpreter .. Jon 11/08/88
\



: Equ	CC/I
  dup get-token drop
  sc/c(s)-page  0 curr-page!  sc/c(s)	\ Save voc env.
  'Equates(s) 2@(g) 2dup context(s) 2!(p)
  set-definitions(s)			\ force equates page
  cs> 'word Current(s) 2@(p) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
  If
  	rot drop		\ drop extra copy of EQU value
  	2dup  pcr >name(s) .name(s) ."  is reset"  pcr
  	rot >r 2dup r@ -rot !(s)l  "" EQ" r> 2swap (.log)
  Else
  	drop  (host-create) ,(s)
       "" EQ" swap latest-chunk @(v) last'(s)@ (.log)
	Is-resolved
  Endif
  rc/c(s)  ;			\ restore voc env.




\ Interpreter .. sfp 21/02/90
\


: Label	CC/I
	dup get-token drop
	sc/c(s)-page  0 curr-page!  sc/c(s)
	'Labels(s) 2@(g)  2dup context(s) 2!(p)
	set-definitions(s)				\ force labels page
	host-create "" LB" swap .log
	rc/c(s)  ;


: L:	CC/I
	Assembl?
	If
		asm_end
	Endif
	here(t) [+interpreter] LABEL [previous]  ;


: Proc	cc/i
  [+interpreter]
  assembler l:
  [previous]
;

: User	CC/I
	?0-even  get-token drop  create
	"" US" here(t) .log
	target USER compile-run
	,(t)  ;




\ From From-File ( \ .. sfp 14/04/89
\

: From-File	cc/i		( first last -- ; <file> )
  cs> get-token
  2dup  dup c@ 1+  curr-text$  rot  cmovel      \ force USE name
  $from  ;


: From	cc/i		( first last -- )
  curr-text$
  $from  ;


: (	cc/i		( -- )
	[compile] (  ;


: (( cc/i	( -- )
	[compile] ((  ;


: \	cc/i		( -- )
  [compile] \  ;




\ Interpreter .. sfp 14/04/89
\


: Load	CC/I		( n -- )
	Blk @ >r   >In @ >r   >In off   Blk !
	interpret(t)
	r> >In !   r> Blk !  ;

: FConstant	CC/I
  ?0-even 3dup bl-word-up  create
  "" FC" here(t) .log
  Target FCONSTANT compile-run
  ,(t) ,(t) ,(t)
  make-float-data-packet
;

: FArray	CC/I
  ?0-even bl-word-up  create
  "" FA" here(t) .log
  Target FARRAY compile-run
  0 Do ,(t) ,(t) ,(t) Loop
;

: 2Constant	CC/I
  ?0-even 2dup bl-word-up  create
  "" DC" here(t) .log
  Target 2CONSTANT compile-run
  ,(t) ,(t)
  make-double-data-packet
;

: Constant	CC/I
  ?0-even dup bl-word-up  create
  "" CN" here(t) .log
  Target CONSTANT compile-run
  ,(t)
  make-c/v-data-packet
;

: Host&Target	CC/I
	Do-Build on(g)  ;


: Target-Only	CC/I
	Do-Build off(g)  ;




\ Interpreter .. Jon 13/08/88
\


hex

: Create	CC/I
  ?0-even  bl-word-up  create
  "" CR" here(t) .log
  DOCREATE,  here(t)
  make-c/v-data-packet  ;


: Variable	CC/I
  ?0-even  bl-word-up  create
  "" VR" here(t) .log
  ?Rom @(g)
  If    Rom-var(t)
  Else  Ram-var(t)
  Endif
  make-c/v-data-packet  ;


: 2Variable	CC/I
  ?0-even  bl-word-up  create
  "" DV" here(t) .log
  ?Rom @(g)
  If   Rom-Double(t)
  Else Ram-Double(t)
  Endif
  make-c/v-data-packet  ;

: FVariable	CC/I
  ?0-even  bl-word-up  create
  "" FV" here(t) .log
  ?Rom @(g)
  If   Rom-Float(t)
  Else Ram-Float(t)
  Endif
  make-c/v-data-packet  ;


\ Interpreter .. sfp 14/04/89
\


hex

: CVariable	CC/I
	?0-even bl-word-up  create
	"" VR" here(t) .log
	target VARIABLE compile-run
	?Rom @(g)
	If
		there(t) dup ,(t)  0 c,(r)
	Else
		here(t)  0 c,(t)
	Endif
	make-c/v-data-packet  ;




\ Interpreter .. sfp 14/04/89
\


: !	CC/I
  !(x)					\
;


: @	CC/I
  @(x)					\
;

: C!	CC/I
  c!(x)					\
;

: C@	CC/I
  c@(x)					\
;

: +!	CC/I
  +!(x)
;

: ,	CC/I
  ,(t)  ;


: C,	CC/I
  c,(t)  ;




\ Interpreter .. sfp 19/09/89
\


: Cmove	CC/I
  cmove(t)  ;


: Erase	CC/I
  erase(t)  ;


: Fill	CC/I
  fill(t)  ;


: [	CC/i
	([)  ;


: ]	CC/I
	(])  ;




\ Interpreter .. sfp 15/08/88
\


hex

: Is-Fence	CC/I
	latest(t) fence(t) !(g)  ;


: There	CC/I
	there(t)  ;


: Literal	CC/I
	?comp  ;


: DLiteral	CC/I
	?comp  ;


: Thru	CC/I		( start end -- )
	1+ swap
	Do
		i [+interpreter] LOAD [previous]
	Loop  ;




\ Interpreter .. sfp 19/09/89
\



: Thru-Using	CC/I	 ( start-screen# end-screen# --- ; <file-name> )
	pcr cs> get-token $using
	If
		re-open   8 error
	Endif
	pcr .curr-file pcr
        redraw-bottom-bar
	[+interpreter] THRU [previous]
	pcr ." Finished with " .scr pcr re-using  ;


: Load-Using	CC/I		( screen# --- ; <file-name> )
	pcr cs> get-token $using
	If
		re-open   8 error
	Endif
	pcr .curr-file pcr
        redraw-bottom-bar
	[+interpreter] LOAD [previous]
	pcr ." Finished with " .scr pcr re-using  ;




\ Conditional Interpretation .. sfp 15/08/88
\


: If(	CC/I
	c-if  ;


: )Else(	CC/I
	c-else  ;


: )Endif	CC/I
	c-endif  ;




\ Immediate word compilation .. Jon 10/08/88
\


: I:	CC/I
	[+interpreter] : [previous]
	Do-Build @(g)
	If 
		sc/c  Compiler definitions
		word-down context-find
		If
			drop
		Else
			(head-create)
		Endif
		rc/c
	Endif  ;




\ defer .. Jon 13/08/88
\


: Defer	CC/I
  ?0-even get-token drop  create
  "" DF" here(t) .log
  target DEFER compile-run
  ?Rom @(g)
  If
    there(t) ,(t)
    kernel-ram-page @(g)  curr-data-page @(g)  =
    If
      target CRASH 2dup resolved? 0= 01b ?error
      @(s)l ,(r)
    Else
      cell(t) allot-ram       \ action set by target
    Endif
  Else
    target CRASH compile-ref
  Endif  ;




\ assign to-do .. sfp 09/04/90
\


: Assign	CC/I		( cfa -- )
	'(t)  ;


: To-Do	CC/I	( cfa -- ; to-do <word> )
  '(t) >body(t)				\ find target body
  ?Rom @(g)				\ ROM target?
  If  @(t) !(x)				\
  Else !(t)				\
  Endif					\ if ROM, RAM addr at pf
;



\ vocabulary switching - interpreter .. sfp 21/02/90
\


: Forth	CC/I
	'Forth(s) 2@(g) Context(s) 2!(p)  ;


: Only	CC/I
	only(s)  ;


: Also	CC/I
	also(s)  ;


: Previous	CC/I
	previous(s)  ;


: Definitions	CC/I
	definitions(s)  ;


: Alias	cc/i		( -- ; use ALIAS <old> <new> )
  '(t)							\ get cfa of <old>
  get-token drop  host-create  ;		\ make <new> symbol




\ host/target compilation control .. sfp 14/04/89
\


: Host-Compilation	CC/I
	Host-Mode on(g)
	Forth definitions  ;


: CC/I	CC/I		( allow vocabulary switches after HOST-COMPILATION )
	[compile] cc/i  ;	IMMEDIATE


: C-C	CC/I
	[compile] c-c  ;	IMMEDIATE




