\ code to control hso0
\ generates a square wave under interrupts, on HSO0

((
This code released as example code only, for use with
80c196 cross-compiler
(c) MicroProcessor Engineering Ltd., 1991
133 Hill Lane
Southampton
SO1 5AF

Phone: (+44) 703 631441
Fax:   (+44) 703 339691

))

\ -----End of Page-----
\ -- R.G.G -- 3/12/91 --  constants and variables

hex

\ -- addr ; sfr register addresses

06 constant HSO-command
04 constant HSO-time
08 constant init-mask

decimal

variable hso0-time			\ copy of the time set
variable hso0-status			\ copy of the level of the port
variable interval

\ -----End of Page-----
\ -- R.G.G -- 3/12/91 --  interrupt code

hex

: set-hso		\ time channel -- ; set channel high
  0f and				\ mask channel#
  020 or				\ set the `set' bit
  010 or				\ set the `int' bit
  hso-command c!			\ set the command
  dup hso-time !			\ set the time for it
  hso0-time !				\ set the shadow copy
  hso0-status on			\ say so
;

: reset-hso		\ time channel -- ; reset channel low
  0f and				\ mask channel#
  010 or				\ set the `int' bit
  hso-command c!			\ set the command
  dup hso-time !		    	\ set the time for it
  hso0-time !				\ set the shadow copy
  hso0-status off			\ say so
;

: toggle-hso		\ time channel -- ; toggle a channel
  hso0-status @				\ get current state
  if
    reset-hso				\ clear the bit
  else
    set-hso				\ or set the bit
  endif
;

: square-wave		\ -- ; interrupt routine
  interval @ hso0-time @ +		\ get the time, and calculate next one 
  0 toggle-hso				\ set it on channel 0
;

HEX

l: sqw-int
 ] square-wave reti [                   \ action, return

ASSEMBLER                               \
l: hso-ivec                             \ registers saved by IRQ
  pushf   push ip                       \ save PSW and IP
  ld ip # sqw-int   ljmp next-int       \ load new IP
FORTH

hso-ivec 02006 !                        \ set vector

\ -----End of Page-----
\ -- R.G.G -- 3/12/91 --  init-wave

: init-wave		\ interval -- ; set up and do
  interval !			\ initialise the interval variable
  08 init-mask set-bit		\ enable hso interrupts
  ei
  0 0 reset-hso			\ use reset-hso to initialise interrupts etc
;

