\ I/O words for 8096/80C196 systems                  sfp 10/01/89

\ Copyright (C) 1988, 1989

\ MicroProcessor Engineering
\ 133/133a Hill Lane
\ Shirley
\ Southampton SO1 5AF

\ tel (+44) 703 631441

\ 80C196 internal serial port                      sfp 05/02/89

hex

040 equ ri-bit          \ receiver ready bit
020 equ ti-bit          \ transmitter ready bit
0BF equ /ri-bit         \ reset mask
0DF equ /ti-bit         \ reset mask
6   equ ri-bit#
5   equ ti-bit#


\ baud rate equates                                sfp 18/12/90

hex

\ 12 MHz baud rates for 196 - divide lsb by 4 for 96
\ 0804D equ baud9600
\ 0809B equ baud4800
\ 08138 equ baud2400
\ 08270 equ baud1200

\ 10 MHz baud rates for 196KB - divide lsb by 4 for 96
  08040 equ baud9600
  08081 equ baud4800
  08103 equ baud2400
  08208 equ baud1200

\ 8 MHz baud rates for 196 - divide lsb by 4 for 96
\ 08033 equ baud9600
\ 08067 equ baud4800
\ 080CF equ baud2400
\ 081A0 equ baud1200

\ init-ser-sub init-ser                            sfp 04/02/89

hex

assembler
l: init-ser-sub \ initialise serial port
  jbc 016 5 $    jbc 016 5 $   jbc 016 5 $  \ wait for UART
  ldb baudrate # sysbaud .lo		\ initialise baud rate
  ldb baudrate # sysbaud .hi		\
  ldb ioc1 # 020			\ IOC1.5 to 1
  ldb sp_con # 09			\ REN=1, mode=1
  ldb spshadow # ti-bit			\ mark ready to xmit
  ret
forth

code init-ser   \ -- ; initialise serial port
  scall init-ser-sub   next,   end-code


\ (emit) (key) (key?)

code (emit)     \ char -- ; transmit character
  scall pemit   pop tos   next,
l: pemit
  jbs spshadow ti-bit# pemit1           \ skip if xmit ready
l: pemit2
     orb spshadow sp_con		\ read status reg
     jbc spshadow ti-bit# pemit2
l: pemit1
  andb spshadow # /ti-bit               \ reset ti bit in shadow
  ldb sbuf tos.l                        \ output character
  ret
end-code

code (key)      \ -- char ; receive a character
  push tos				\ save previous TOS
  jbs spshadow ri-bit# pkey1            \ skip if char ready
l: pkey2
    orb spshadow sp_con			\ read status
    jbc spshadow ri-bit# pkey2          \ test receive status
l: pkey1
  andb spshadow # /ri-bit               \ reset ri bit in shadow
  ldbze tos sbuf                        \ receive character
\ andb tos.l # 07F                      \ convert to 7 bits
  next,   end-code

code (key?)     \ -- t/f ; true if character available
  push tos                              \ preserve old TOS
  ld tos # -1                           \ assume success
  jbs spshadow ri-bit# pkeyq1           \ skip if char ready
  orb spshadow sp_con			\ read status
  jbs spshadow ri-bit# pkeyq1           \ skip if char ready
  clr tos                               \ set accordingly
l: pkeyq1
  next,   end-code                      \ all done

\ 8096 family terminal I/O                         sfp 25/03/90

HEX

: DEMIT		\ -- ; character output
  (EMIT)  1 OUT +!  ;

defer emit
  assign demit to-do emit

defer key
  assign (key) to-do key

defer key?
  assign (key?) to-do key?

: TYPE		\ addr len -- ; display string
  BOUNDS
  ?DO  I C@ EMIT  LOOP  ;

: CR		\ -- ; display CR/LF pair
  0D EMIT  0A EMIT  OUT OFF  ;

