\ SINE COSINE tests for Kurt Heinz                   sfp 26/06/90

((
Copyright (c) 1988-1991 to:

Kurt Heinz @ Synics
and
MicroProcessor Engineering Limited
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441   ( international )
tel: 0703 631441        ( domestic )

Developed from code presented by John James in Forth Dimensions.

The input to these functions is in units of .1 degree, i.e. 900
represents a right angle. The output is scaled to 10000.

The input scaling is hard coded unfortunately, but the output scaling
is determined by the scale value 10K.
))
\ scaled integer SIN function                      sfp 26/06/90

decimal

10000 constant 10k      \ scaling constant

variable XS             \ square of the scaling angle


: l             \ a b -- m ; m=10000-ax*x/b .. a common term
  xs @ swap s/ negate  10k s*/  10k +  ;

: (sin)         \ theta -- 10000*sin ; -15708 < theta < 15708
  dup dup 10k s*/ xs !                  \ save x^2
  10k                                   \ start with 1=10,000
  72 l  42 l  20 l  6 l                 \ compute series terms
  10k s*/  ;                            \ finally mult by x

: ?mirror       \ theta -- theta' ; reduce range
  dup 900 >				\ reduce 0..180 to -90..+90
  if  1800 swap -  endif  ;

: reduce        \ theta -- theta' ; more range reduction
  3600 mod  dup 0<			\ translate to 0..360
  if  3600 +  endif
  dup 1800 <				\ translate to -90..+90
  if  ?mirror
  else  1800 - ?mirror negate
  endif  ;


\ sin cos tan in .1 degree steps                   sfp 26/06/90

: sin           \ theta -- 10000*sin
  reduce  17453 1000 s*/                \ deg to rad * 10000
  (sin)  ;

: cos           \ theta -- 10000*cos
  3600 mod  900 swap - sin  ;

: tan           \ theta -- 100*tan ; N.B. DIFFERENT output scale
  dup sin  swap cos			\ evaluate as tan=sin/cos
  dup -18 17 within?			\ check for out of range value
  if  1 min -1 max			\ sign of cos
      swap 1 min -1 max  *		\ sign of sine
      30000 *  dup 0=			\ scale
      if  drop 30000  endif		\ replace if sign=0
  else  100 swap s*/			\ scale by 100
  endif  ;

\ all done

decimal

;p
