\ Paging example target definition file

pto

Released for use with the MPE Forth Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441   (international)
     0703 631441        (domestic)
fax: (+44) 703 339691

\ start here

only forth definitions decimal

  all from-file nextfast	\ macro for fast NEXT
\ all from-file nextjp		\ macro for short NEXT

\  Hex 0320 Emu-Base		\ set emulator i/o address
\  e27256 8bit output-emulator	\ output to emulator

Floats				\ switch floating point on

Cross-Compile			\ switch compiler on

Only Forth Definitions		\ target search order

\ no-log

\ memory definitions                               sfp 10/05/91
hex

\ define fixed page
      $0000 $7FFF 0 KERNEL-PAGE KERN		\ Kernel ROM: 0h->7FFFh
      $8000 $8FFF 1 KERNEL-DATA KERN-DATA	\ Kernel RAM: 8000h->8FFFh

\ Define page 1 code and data
      $9000 $9FFF 2 CODE-PAGE   PAGE1		\ Page 1: 9000h->9FFFh
      $A000 $AFFF 3 DATA-PAGE   PAGE1-DATA	\ Page 1: A000h->AFFFh

\ Define page 2 code and data
      $B000 $BFFF 4 CODE-PAGE   PAGE2		\ Page 2: B000h->BFFFh
      $C000 $CFFF 5 DATA-PAGE   PAGE2-DATA	\ Page 2: C000h->CFFFh

      $C000         MEM-END			\ RAM ends at BFFFh

\      $0000 IN-EMULATOR KERN			\ Output to emulator

      0C000 equ appl-rom			\ Define application area
      0FFFF equ appl-rom-end			\ both start and finish

\ Select fixed page code and data
use-code KERN					\ Select code page
use-data KERN-DATA				\ Select data page

\ task definitions                                 sfp 10/05/91
hex
\ A task uses an amount of RAM (usually 256 bytes) for its
\ User area and stacks. For example this might be:
\ 0C0..0FF      Return stack
\ 080..0BF      Data stack
\ 000..07F      User area
\ Another area is provided so that high level interrupt
\ handlers can have a separate and constant user area.

\ Define the maximum number of tasks to be active
8 equ #tasks

\ Define the amount of RAM required per task
0100 equ per-task

\ system addresses and equates                      \  13/05/91

080 EQU TIB-LEN				\ terminal i/p buffer length

EM      \ length            name
         per-task - dup equ INT-INIT-U0	\ base of interrupt area
#tasks per-task * - dup equ INIT-U0	\ base of task user area
          tib-len - dup equ INIT-TIB	\ base of TIB
drop

\ Place the stacks inside the first task area
init-u0 0100 + equ INIT-R0
init-u0 00C0 + equ INIT-S0

\ pull in the files

\ Kernel in fixed page
use-code KERN					\ Select code page
use-data KERN-DATA				\ Select data page

  decimal all from-file startxx.fth		\ vectors and startup

  decimal all from-file codexx			\ code definitions
  decimal all from-file drivers\rom-io		\ io driver
  decimal all from-file kernel			\ main part of Forth
  decimal all from-file romtools		\ nucleus extensions
  decimal all from-file interupt		\ interrupt handler

\ Floating point in page 1
use-code PAGE1					\ Select code page
use-data PAGE1-DATA				\ Select data page

\ Software floating point
  decimal all from-file softfp\fpromhi.fth	\ Floating point primitives
  decimal all from-file softfp\softfp.fth	\ High level floting point

\ Romforth in page 2
use-code PAGE2					\ Select code page
use-data PAGE2-DATA				\ Select data page

\ the ROMForth files
  decimal all from-file romforth\link		\ linker
  decimal all from-file romforth\iodef		\ io definitions
  decimal all from-file romforth\filetran	\ source load
  decimal all from-file romforth\bin-down	\ binary > host
  decimal all from-file romforth\hex-down	\ hex > host
  decimal all from-file romforth\textfile	\ text files
  decimal all from-file romforth\blocks		\ blocks

\ terminate compilation

: Forth-83  ;

FINIS

;p
