\ ROM Forth XMODEM file upload tool       

((
Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

First Release: 29/04/91

Changes:	See RELEASE.DOC for full details
))

\ Constants & Variables                            sfp 12/09/89

internal

hex
01 constant SOH                         \ File transfer
04 constant EOT                         \   constants
decimal

variable BLK#                           \ Current Block No.
variable CUR-ADDRESS                    \ Current host address
variable LAST-BYTES                     \ #bytes mod 128 decimal


\ X-buffer To-Buffer                               sfp 26/03/90
decimal

: x-buffer	\ -- addr ; return address of buffer
  here 64 +  ;                          \ just above here

: To-Buffer	\ -- ;move data into buffer
  CUR-ADDRESS @ X-buffer 128 cmove      \ Move 128 bytes from
  128 cur-address +!  ;                 \ memory pointed to by
                                        \ CUR-ADDRESS into buff
: ?Ack          \ -- ; wait for ACK
  ser-key ACK <>                        \ wait for response
  IF  EOT ser-emit                      \ flag end of XMODEM
      1 abort" File Transfer error"     \ MUST be ACK
  ENDIF  ;


\ Send-Block ...........................           sfp 12/09/89

Decimal

: Send-Block	\ Blk# -- ; send block of given number
  SOH ser-emit                          \ Start of header
  dup ser-emit                          \ Block Number
  not ser-emit                          \ 1's complement Block#
  0  X-buffer 128 bounds                \ Send 128 byte Block
  DO  i c@                              \ get byte from buffer
      dup ser-emit                      \ transmit it
      + 255 and                         \ Add to Check-Sum
  LOOP                                  \
  ser-emit                              \ Send Check-Sum
  ?Ack  ;                               \ wait response

\ Calc-Last-Bytes, Send-Last-Blk .......           sfp 12/09/89

Decimal

: Calc-Last-Bytes	\ #cells -- #blks
  0 128 um/mod                          \ use 128 byte chunks
  swap last-bytes !                     \ no. of remaining bytes
  1 blk# !  ;                           \ start with block 1

: Send-Last-Blk		\ -- 
  last-bytes @ ?dup                     \ any bytes left ?
  if  x-buffer 128 blank                \ erase buffer
      cur-address @ x-buffer rot cmove  \ copy last bits to buff
      blk# @ send-block                 \ send block
  endif  ;


\ Bin-Down .............................           sfp 12/09/89

External

: Bin-Down	\ addr #bytes --
  cr cr ." Start XMODEM receiver - [PgDn],1 with ProComm" cr
  swap CUR-ADDRESS !                    \ Start from addr
  calc-last-bytes                       \ This is for last Block
  BEGIN ser-key NAK = UNTIL             \ Wait for receiver ...
  1+ 1                                  \ block numbers from 1
  ?DO  to-buffer                        \ Transfer mem to buffer
       i send-block                     \ Send this block
       1 BLK# +!                        \ Count blocks sent
  LOOP                                  \
  send-last-blk                         \ Check for last Block
  EOT ser-emit  ?Ack                    \ terminate XMODEM
  cr ." File transfer successful" cr  ;

